commit abef0531c0676680cab9b1fbd91da4482e35d45d
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Mon Dec 8 16:02:57 2025 +0000

    DMARC: fix for empty env-from.  Bug 1994

diff --git a/src/src/expand.c b/src/src/expand.c
index 1b5980f5b..e222e8e75 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -719,6 +719,7 @@ static var_entry var_table[] = {
   { "spf_result",          vtype_module,	US"spf" },
   { "spf_result_guessed",  vtype_module,	US"spf" },
   { "spf_smtp_comment",    vtype_module,	US"spf" },
+  { "spf_used_domain",	   vtype_module,	US"spf" },
 #endif
   { "spool_directory",     vtype_stringptr,   &spool_directory },
   { "spool_inodes",        vtype_pinodes,     (void *)TRUE },
diff --git a/src/src/miscmods/dmarc.c b/src/src/miscmods/dmarc.c
index ce000ef8e..a18100c81 100644
--- a/src/src/miscmods/dmarc.c
+++ b/src/src/miscmods/dmarc.c
@@ -206,30 +206,19 @@ if (!dmarc_abort && !sender_host_authenticated)
   int sr = SPF_RESULT_INVALID, origin;
   uschar * spf_human_readable = NULL, * spf_sender_domain;
   gstring * dkim_history_buffer = NULL;
-  typedef const pdkim_signature * (*sigs_fn_t)(void);
+  typedef const pdkim_signature * (*dkim_sigs_fn_t)(void);
+  typedef int (*spf_fn_t)(uschar **);
 
-  /* Use the envelope sender domain for this part of DMARC */
+  if (dmarc_spf_mod_info)
+    sr = ((spf_fn_t *) dmarc_spf_mod_info->functions)[SPF_GET_RESULTS]
+							(&spf_human_readable);
 
-  spf_sender_domain = expand_string(US"$sender_address_domain");
-
-    {
-    typedef int (*fn_t)(uschar **);
-    if (dmarc_spf_mod_info)
-      sr = ((fn_t *) dmarc_spf_mod_info->functions)[SPF_GET_RESULTS]
-							  (&spf_human_readable);
-    }
+  spf_sender_domain = expand_string(US"$spf_used_domain");
 
   if (sr == SPF_RESULT_INVALID)
     {
-    /* No spf data means null envelope sender so generate a domain name
-    from the sender_helo_name  */
-
-    if (!spf_sender_domain || !*spf_sender_domain)
-      {
-      spf_sender_domain = sender_helo_name;
-      log_write(0, LOG_MAIN, "DMARC using synthesized SPF sender domain = %s\n",
-			     spf_sender_domain);
-      }
+    DEBUG(D_receive) debug_printf_indent("DMARC: spf result 'invalid'\n");
+
     dmarc_spf_result = DMARC_POLICY_SPF_OUTCOME_NONE;
     dmarc_spf_ares_result = ARES_RESULT_UNKNOWN;
     origin = DMARC_POLICY_SPF_ORIGIN_HELO;
@@ -237,11 +226,12 @@ if (!dmarc_abort && !sender_host_authenticated)
     }
   else
     {
-    dmarc_spf_result = sr == SPF_RESULT_NEUTRAL  ? DMARC_POLICY_SPF_OUTCOME_NONE :
-		       sr == SPF_RESULT_PASS     ? DMARC_POLICY_SPF_OUTCOME_PASS :
-		       sr == SPF_RESULT_FAIL     ? DMARC_POLICY_SPF_OUTCOME_FAIL :
-		       sr == SPF_RESULT_SOFTFAIL ? DMARC_POLICY_SPF_OUTCOME_TMPFAIL :
-		       DMARC_POLICY_SPF_OUTCOME_NONE;
+    dmarc_spf_result =
+      sr == SPF_RESULT_NEUTRAL  ? DMARC_POLICY_SPF_OUTCOME_NONE :
+      sr == SPF_RESULT_PASS     ? DMARC_POLICY_SPF_OUTCOME_PASS :
+      sr == SPF_RESULT_FAIL     ? DMARC_POLICY_SPF_OUTCOME_FAIL :
+      sr == SPF_RESULT_SOFTFAIL ? DMARC_POLICY_SPF_OUTCOME_TMPFAIL :
+      DMARC_POLICY_SPF_OUTCOME_NONE;
     dmarc_spf_ares_result = sr == SPF_RESULT_NEUTRAL   ? ARES_RESULT_NEUTRAL :
 			    sr == SPF_RESULT_PASS      ? ARES_RESULT_PASS :
 			    sr == SPF_RESULT_FAIL      ? ARES_RESULT_FAIL :
@@ -269,7 +259,7 @@ if (!dmarc_abort && !sender_host_authenticated)
   the opendmarc context, further building the DMARC reply. */
 
   for(const pdkim_signature * sig =
-	      (((sigs_fn_t *)dmarc_dkim_mod_info->functions)[DKIM_SIGS_LIST])();
+	(((dkim_sigs_fn_t *)dmarc_dkim_mod_info->functions)[DKIM_SIGS_LIST])();
       sig; sig = sig->next)
     {
     int dkim_result, dkim_ares_result, vs, ves;
diff --git a/src/src/miscmods/dmarc_native.c b/src/src/miscmods/dmarc_native.c
index aa28df583..f0c91868b 100644
--- a/src/src/miscmods/dmarc_native.c
+++ b/src/src/miscmods/dmarc_native.c
@@ -360,7 +360,8 @@ if (!dmarc_abort && !sender_host_authenticated)
     };
 
   int sr = SPF_RESULT_INVALID /*, spf_origin*/;
-  uschar * spf_human_readable = NULL, * spf_sender_domain = NULL;
+  uschar * spf_human_readable = NULL;
+  const uschar * spf_sender_domain = NULL;
   unsigned dkim_sig_count = 0;
   gstring * dkim_history_buffer = NULL;
   typedef const pdkim_signature * (*sigs_fn_t)(void);
@@ -502,30 +503,19 @@ if (!dmarc_abort && !sender_host_authenticated)
     int spf_result;
     typedef int (*fn_t)(uschar **);
 
-    /* Use the envelope sender domain for this part of DMARC */
-
-    spf_sender_domain = expand_string(US"$sender_address_domain");
-
     if (dmarc_spf_mod_info)
       sr = ((fn_t *) dmarc_spf_mod_info->functions)[SPF_GET_RESULTS]
 							  (&spf_human_readable);
 
+    spf_sender_domain = expand_string(CUS"$spf_used_domain");
+
     if (sr == SPF_RESULT_INVALID)
       {
-      /* No spf data means null envelope sender so generate a domain name
-      from the sender_helo_name  */
-
       DEBUG(D_receive) debug_printf_indent("DMARC: spf result 'invalid'\n");
 
-      if (!spf_sender_domain || !*spf_sender_domain)
-	{
-	spf_sender_domain = sender_helo_name;
-	log_write(0, LOG_MAIN, "DMARC using synthesized SPF sender domain = %s\n",
-			       spf_sender_domain);
-	}
       spf_result = DMARC_POLICY_SPF_OUTCOME_NONE;
       dmarc_spf_ares_result = ARES_RESULT_UNKNOWN;
-      /* spf_origin = DMARC_POLICY_SPF_ORIGIN_HELO; */
+      /* spf_origin = DMARC_POLICY_SPF_ORIGIN_HELO; not used, and we'd want to ask the spf impl really */
       spf_human_readable = US"";
       }
     else
diff --git a/src/src/miscmods/spf.c b/src/src/miscmods/spf.c
index d97995d56..a0cdb8dc6 100644
--- a/src/src/miscmods/spf.c
+++ b/src/src/miscmods/spf.c
@@ -42,7 +42,8 @@ uschar * spf_smtp_comment       = NULL;
 uschar * spf_smtp_comment_template
                     /* Used to be: "Please%_see%_http://www.open-spf.org/Why?id=%{S}&ip=%{C}&receiver=%{R}" */
 				= US"Please%_see%_http://www.open-spf.org/Why";
-BOOL    spf_result_guessed     = FALSE;
+BOOL    spf_result_guessed	= FALSE;
+const uschar * spf_used_domain	= NULL;
 
 
 
@@ -409,6 +410,9 @@ else
   spf_received           = US SPF_response_get_received_spf(spf_response);
   spf_result             = US SPF_strresult(SPF_response_result(spf_response));
   spf_smtp_comment       = US SPF_response_get_smtp_comment(spf_response);
+  spf_used_domain	 = sender_address && *sender_address
+			  ? expand_string(US"$sender_address_domain")
+			  : sender_helo_name;
 
   rc = SPF_response_result(spf_response);
 
@@ -595,6 +599,7 @@ static var_entry spf_variables[] = {
   { "spf_result",		vtype_stringptr,	&spf_result },
   { "spf_result_guessed",	vtype_bool,		&spf_result_guessed },
   { "spf_smtp_comment",		vtype_stringptr,	&spf_smtp_comment },
+  { "spf_used_domain",		vtype_stringptr,	&spf_used_domain },
 };
 
 misc_module_info spf_module_info =
diff --git a/src/src/miscmods/spf_perl.c b/src/src/miscmods/spf_perl.c
index 55741eef0..c30e0efe4 100644
--- a/src/src/miscmods/spf_perl.c
+++ b/src/src/miscmods/spf_perl.c
@@ -43,7 +43,8 @@ uschar * spf_smtp_comment       = NULL;
 uschar * spf_smtp_comment_template
                     /* Used to be: "Please%_see%_http://www.open-spf.org/Why?id=%{S}&ip=%{C}&receiver=%{R}" */
 				= US"Please%_see%_http://www.open-spf.org/Why";
-BOOL    spf_result_guessed     = FALSE;
+BOOL    spf_result_guessed	= FALSE;
+const uschar * spf_used_domain	= NULL;
 
 
 static const misc_module_info * spf_perl_mi = NULL;
@@ -196,6 +197,10 @@ else
     uschar * t = Ustrchr(s, ')');	/* grab a (comment) if there is one */
     if (t) spf_header_comment = string_copyn(s+1, t-s-1);
     }
+
+  spf_used_domain	 = sender_address && *sender_address
+			  ? expand_string(US"$sender_address_domain")
+			  : sender_helo_name;
   }
 
 res = match_isinlist(spf_result, &arglist,
@@ -344,6 +349,7 @@ static var_entry spf_variables[] = {
   { "spf_result",		vtype_stringptr,	&spf_result },
   { "spf_result_guessed",	vtype_bool,		&spf_result_guessed },
   { "spf_smtp_comment",		vtype_stringptr,	&spf_smtp_comment },
+  { "spf_used_domain",		vtype_stringptr,	&spf_used_domain },
 };
 
 misc_module_info spf_module_info =

